"""This modul provides the interface to nagios

Common informations:
    This software is made for usage with the nagios monitoring system.
    If you change something or add new features please send a message to
    the author.

Licence:
    This program is free software; you can redistribute it and#or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

Author: Andy-Kim Moeller <kim@ypsilon.net>
"""

import sys

class NagiosUtils:
	"""Small class fo returning nagiosunderstandable messages
	"""

	# NAGIOS STATUS INFORMATION MAPPING
	OK = 0
	WARNING = 1
	CRITICAL = 2
	UNKNOWN = 3
	DEPENDENT = 4

	def tell(self,status,msg):
		"""Exit the system with the right status and print the message
		@status : in ['OK','WARNING','CRITICAL','UNKNOWN','DEPENDENT'] or in [0 .. 4]
		@msg : string
		"""
		if type(status) == type(0):
			# STATUS IS GIVEN AS INTEGER
			if status in [0,1,2,3,4]:
				statusFlag = status
			else:
				statusFlag = self.UNKNOWN
				msg = '%s (Check programming error. Status (%s) unknown)' % (str(status).upper())
		else:
			# STATUS IS IN STRING
			try:
				# IF CLASS HAS THIS STATUS ATTRIBUTE
				statusFlag = getattr(self,str(status).upper())
			except:
				# IF THIS STATUS IS UNKNOWN
				statusFlag = self.UNKNOWN
				msg = '%s (Check programming error. Status (%s) unknown)' % (str(status).upper())
		print msg
		sys.exit(statusFlag)
